import std.stdio;
import std.utf;

void main()
{
	// myprint("Foobar"); // see below
	myprint("Foobar"c);
	myprint("Foobar"w);
	myprint("Foobar"d);

    writefln("   U+FEF8 'arabic ligature lam with alef with hamza above final form'");
    writefln("   should look like a mirrored hand written K with crap below at left");
    writefln("Direct inserted with text editor");
	myprint("FEF8:ﻸ"c); // direct insert
	myprint("FEF8:ﻸ"d); // direct insert
	myprint("FEF8:ﻸ"w); // direct insert
    writefln("Inserted as backslash-and-hex");
	myprint("With uXXXX code: \uFEF8"c);
	myprint("With uXXXX code: \uFEF8"d);
	myprint("With uXXXX code: \uFEF8"w);

    writefln("   U+0429 'cyrillic capital letter shcha");
    writefln("   should look like three vertical bars joined at bottom with");
    writefln("   a horizontal bar having a small hanging crap at right end");
    writefln("Direct inserted with text editor");
	myprint("0429:Щ"c);
	myprint("0429:Щ"w);
	myprint("0429:Щ"d);
    writefln("Inserted as backslash-and-hex");
	myprint("With uXXXX code: \u0429"c);
	myprint("With uXXXX code: \u0429"d);
	myprint("With uXXXX code: \u0429"w);
}

void myprint( char[] s) {_myprint( toUTF8(s) );}
void myprint(wchar[] s) {_myprint( toUTF8(s) );}
void myprint(dchar[] s) {_myprint( toUTF8(s) );}

void _myprint(char[] s)
{
	char[] cs;
	wchar[] ws;
	dchar[] ds;

	cs = toUTF8(s) ; writefln(cs);
	ws = toUTF16(s); writefln(ws);
	ds = toUTF32(s); writefln(ds);
}
